﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager runat="server" ID="ScriptManager1">
    </asp:ScriptManager>

    <script type="text/javascript">
        function lb1dropped(sender, args) {
            transferManager.performTransfer(sender, args);
        }

        function lb2dropped(sender, args) {
            transferManager.performTransfer(sender, args);
        }

        function lb3dropped(sender, args) {
            transferManager.performTransfer(sender, args);
        }

        
        (function($) {
            transferManager = function() { }

            transferManager.performTransfer = function(sender, args) {
                var destinationItemIndex = this._getDestinationIndex(args);
                var destinationListBox = this._getDestinationListBox(args);

                if (destinationListBox == null)
                    return;

                var reorderIndex = args.get_dropPosition() == 0 ?
                destinationItemIndex : destinationItemIndex + 1;

                var items = args.get_sourceItems();

                this._transfer(items, destinationListBox, reorderIndex);

            }

            transferManager._transfer = function(items, destination, reorderIndex) {
                $.each(items, function(index, item) {
                    item.unselect();
                    destination.get_items().insert(reorderIndex, item);
                });
            }

            transferManager._getDestinationIndex = function(args) {
                var destinationItem = args.get_destinationItem();
                if (destinationItem)
                    return destinationItem.get_index();

                return 0;
            }

            transferManager._getDestinationListBox = function(args) {
                var destinationItem = args.get_destinationItem();

                if (destinationItem) {
                    var id = destinationItem.get_listBox().get_id();
                    return $find(id);
                }

                var parent = $(args.get_htmlElement()).parent();
                if (parent.is(".RadListBox")) {
                    var id = parent[0].id;
                    return $find(id);
                }
                else if (parent.is(".rlbGroup")) {
                    var id = parent[0].parentNode.id;
                    return $find(id);
                }
                return null;
            }
        })($telerik.$);
        
    </script>
    

    <telerik:RadListBox runat="server" ID="RadListBox1" EnableDragAndDrop="true" OnClientDropped="lb1dropped">
        <Items>
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem1" />
        </Items>
    </telerik:RadListBox>
    <telerik:RadListBox runat="server" ID="RadListBox2" EnableDragAndDrop="true" OnClientDropped="lb2dropped">
        <Items>
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem1" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem2" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem3" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem4" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem5" />
        </Items>
    </telerik:RadListBox>
    <telerik:RadListBox runat="server" ID="RadListBox3" EnableDragAndDrop="true" OnClientDropped="lb3dropped">
        <Items>
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem1" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem2" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem3" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem4" />
            <telerik:RadListBoxItem runat="server" Text="RadListBoxItem5" />
        </Items>
    </telerik:RadListBox>
    </form>
</body>
</html>
